﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Unitronics.ComDriver;
using System.IO;

namespace SD_Card_Explorer_Lite
{
    public partial class Form1 : Form
    {
        PLC m_PLC;
        public Form1()
        {
            InitializeComponent();
        }

        private void btnConnect_Click(object sender, EventArgs e)
        {
            string path = Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().GetName().CodeBase.Replace(@"file:///", ""));
            string dirSeparator = Path.DirectorySeparatorChar.ToString();
            if (path.Substring(path.Length - 1) == dirSeparator)
                path = path.Substring(0, path.Length - 1);

            try
            {
                this.Enabled = false;
                this.Cursor = Cursors.WaitCursor;
                m_PLC = PLCFactory.GetPLC(path + dirSeparator + "ComSettings.xml");

                btnConnect.Enabled = false;
                btnDisconnect.Enabled = true;

                sdCardExplorer1.Plc = m_PLC;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
            finally
            {
                this.Enabled = true;
                this.Cursor = Cursors.Default;
            }
        }

        private void btnDisconnect_Click(object sender, EventArgs e)
        {
            if (m_PLC != null)
            {
                m_PLC.EventAbortCompleted += new PLC.AbortCompletedDelegate(m_PLC_EventAbortCompleted);
                m_PLC.Abort();
            }
        }

        void m_PLC_EventAbortCompleted()
        {
            m_PLC.Disconnect();
            m_PLC.EventAbortCompleted -= new PLC.AbortCompletedDelegate(m_PLC_EventAbortCompleted);
            sdCardExplorer1.Plc = null;

            // Use anonymous methods to update GUI from another thread
            MethodInvoker uiDelegate = delegate
            {
                btnConnect.Enabled = true;
                btnDisconnect.Enabled = false;
            };
            UpdateUI(uiDelegate);
        }

        protected void UpdateUI(MethodInvoker uiDelegate)
        {
            if (InvokeRequired)
                this.Invoke(uiDelegate);
            else
                uiDelegate();
        }
    }
}
